// Nombre:
// Matrícula:

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_NOMBRE 20

typedef struct persona {
    char nombre[MAX_NOMBRE];
    struct persona * sig;
    struct persona * izq;
    struct persona * der;
} persona_t;

typedef struct arbol_ligado {
    persona_t * raiz;
    persona_t * inicio;
    persona_t * final;
} arbol_ligado_t;

void zape(arbol_ligado_t * al) {
    // Coloca aquí tu código.
    al -> raiz = al -> inicio = al -> final = NULL;
}

void inserta(arbol_ligado_t * al, char * nombre) {

    persona_t * p = malloc(sizeof(persona_t));

    if (!p) exit(1);

    strncpy(p -> nombre, nombre, MAX_NOMBRE);
    p -> sig = p -> izq = p -> der = NULL;

    if (al -> raiz) {
        al -> final -> sig = p;
        al -> final = p;
        persona_t * q = al -> raiz;
        while (true) {
            if (strcmp(nombre, q -> nombre) < 0) {
                if (q -> izq) {
                    q = q -> izq;
                } else {
                    q -> izq = p;
                    break;
                }
            } else {
                if (q -> der) {
                    q = q -> der;
                } else {
                    q -> der = p;
                    break;
                }
            }
        }
    } else {
        al -> raiz = al -> inicio = al -> final = p;
    }
}

void imprime_lista(arbol_ligado_t * al) {
    bool primero = true;
    printf("[");
    persona_t * p = al -> inicio;
    while (p) {
        if (primero) {
            primero = false;
        } else {
            printf(", ");
        }
        printf("%s", p -> nombre);
        p = p -> sig;
    }
    printf("]\n");
}

bool primero;

void imprime_nodo_arbol(persona_t * p) {
    if (p) {
        imprime_nodo_arbol(p -> izq);
        if (primero) {
            primero = false;
        } else {
            printf(", ");
        }
        printf("%s", p -> nombre);
        imprime_nodo_arbol(p -> der);
    }
}

void imprime_arbol(arbol_ligado_t * al) {
    primero = true;
    printf("[");
    imprime_nodo_arbol(al -> raiz);
    printf("]\n");
}

int main(void) {
    arbol_ligado_t x = { NULL, NULL, NULL};
    inserta(&x, "enero");
    inserta(&x, "febrero");
    inserta(&x, "marzo");
    inserta(&x, "abril");
    inserta(&x, "mayo");
    inserta(&x, "junio");
    printf("Antes del zape:\n  ");
    imprime_lista(&x);
    printf("  ");
    imprime_arbol(&x);
    zape(&x);
    printf("Después del zape:\n  ");
    imprime_lista(&x);
    printf("  ");
    imprime_arbol(&x);

    inserta(&x, "Dwalin");
    inserta(&x, "Balin");
    inserta(&x, "Kili");
    inserta(&x, "Fili");
    inserta(&x, "Dori");
    inserta(&x, "Nori");
    inserta(&x, "Ori");
    inserta(&x, "Oin");
    inserta(&x, "Gloin");
    inserta(&x, "Bifur");
    inserta(&x, "Bofur");
    inserta(&x, "Bombur");
    inserta(&x, "Thorin");
    printf("Antes del zape:\n  ");
    imprime_lista(&x);
    printf("  ");
    imprime_arbol(&x);
    zape(&x);
    printf("Después del zape:\n  ");
    imprime_lista(&x);
    printf("  ");
    imprime_arbol(&x);
}
